import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.util.List;
import java.awt.Color;
/**
 * Write a description of class Hunter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Hunter extends Actor
{
    /**
     * Act - do whatever the Hunter wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int stepCounter;
    private static boolean gameOn;
    private static int lives;
    //private static GreenfootImage gfi;
    public Hunter()
    {
        stepCounter = 0;
        gameOn = true;
        lives = 3;
        //Bullet.getOK() = true;
        //gfi = new GreenfootImage(50, 75);
        //this.setImage(gfi);
        
    }
    
    public void act() 
    {
        //this.setImage(gfi);
        if (Hunter.getGameOn() == true)
        {
           //System.out.println(Bullet.getOK());
           stepCounter++;
           this.setRotation(270);
           navigation();
           shoot();
           this.spawnAlien();
        }
        
        else
        {
            this.getWorld().removeObject(this);
            System.out.println("GAME OVER");
        }
        
        if(lives == 0)
        {
            gameOn = false;
        }
        this.stop();
    }   
    
    public void navigation()
    {
        int myX = this.getX();
        
        if(Greenfoot.isKeyDown("left"))
        {
            this.setLocation((this.getX()-5 ), this.getY() );
        }
        
        if(Greenfoot.isKeyDown("right"))
        {
            this.setLocation((this.getX()+5 ), this.getY() );
        }
    }
    
    public void shoot()
    {
        if(Greenfoot.isKeyDown("space"))
        {
            if(Bullet.getOK() == true)
            {
                //System.out.println("Yes");
                Bullet b = new Bullet();
                int myX = this.getX();
                int myY = this.getY(); 
                int myRotation = this.getRotation();
                b.setRotation(myRotation);
                World w = this.getWorld();
                w.addObject(b, myX, myY);
                Bullet.resetOK();
            }
        }
    }
    
    public void spawnAlien()
    {
        World w = this.getWorld();
        ArrayList<Alien> alienList = (ArrayList) w.getObjects(Alien.class);
        if(alienList.size() < 5)
        {
            if( (stepCounter % 75)==0 )
            {
                Alien anAlien = new Alien();
                int width = w.getWidth();
                int randY;
                int randX;
                randX = Greenfoot.getRandomNumber(width);
                randY = Greenfoot.getRandomNumber(75);
                w.addObject(new Alien(), randX,randY);
            }
        }
    }
    
    private static boolean getGameOn()
    {
        return gameOn;
    }
    
    public void stop()
    {
        if (Lives.lives == 0)
        {
            System.out.println("GAME OVER");
            Greenfoot.stop();
            
        }
    }
    
}
